/* GSKrabClient.h - this file is part of GSKrab
 *
 * Copyright (C) 2006 Wolfgang Sourdeau
 *
 * Author: Wolfgang Sourdeau <Wolfgang@Contre.COM>
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This file is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef GSKRABCLIENT_H
#define GSKRABCLIENT_H

#import <Foundation/NSDictionary.h>
#import <Foundation/NSMapTable.h>
#import <Foundation/NSObject.h>

#import <GSKrab/GSKrabKeyCode.h>

@class NSConnection;
@class NSDistantObject;

@protocol GSKrabServer;

@interface GSKrabClient : NSObject
{
  BOOL initialized;
  BOOL serverNotFound;
  NSDistantObject <GSKrabServer> *server;
  NSConnection *serviceConnection;
  NSString *clientName;
  NSString *identifier;
  NSMapTable *actions;
}

+ (GSKrabClient *) sharedKrabClient;

- (void) registerAction: (SEL) action
               onTarget: (id) target
             forKeyCode: (GSKrabKeyCode) krabKeyCode;

- (void) performActionForKey: (GSKrabKeyCode) krabKeyCode;

@end

#endif /* GSKRABCLIENT_H */
